com.io7m.jstructural.core

## Class SDocumentWithSections

- java.lang.Object
- - com.io7m.jstructural.core.SDocument
  - - com.io7m.jstructural.core.SDocumentWithSections

-     @Immutable
      public final class SDocumentWithSections
      extends SDocument

  A document with sections.

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static SDocumentWithSections` | `document(SDocumentTitle in_title, SNonEmptyList<SSection> in_content)` Construct a new document with the given title, and style.
    `<D> D` | `documentAccept(SDocumentVisitor<D> v)` Accept a document visitor.
    `static SDocumentWithSections` | `documentContents(SDocumentTitle in_title, SNonEmptyList<SSection> in_content)` Construct a new document with the given title, and table of contents.
    `static SDocumentWithSections` | `documentStyle(SDocumentTitle in_title, SDocumentStyle in_style, SNonEmptyList<SSection> in_content)` Construct a new document with the given title.
    `static SDocumentWithSections` | `documentStyleContents(SDocumentTitle in_title, SDocumentStyle in_style, SNonEmptyList<SSection> in_content)` Construct a new document with the given title, style, and table of contents.
    `boolean` | `equals(Object obj)`
    `SNonEmptyList<SSection>` | `getSections()`
    `int` | `hashCode()`

    - ### Methods inherited from class com.io7m.jstructural.core.SDocument

      `getContents, getStyle, getTitle`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### document

          public static SDocumentWithSections document(SDocumentTitle in_title,
                                                       SNonEmptyList<SSection> in_content)

      Construct a new document with the given title, and style.
      Parameters:
        `in_title` - The title
        `in_content` - The sections
      Returns:
        A new document

    - #### documentContents

          public static SDocumentWithSections documentContents(SDocumentTitle in_title,
                                                               SNonEmptyList<SSection> in_content)

      Construct a new document with the given title, and table of contents.
      Parameters:
        `in_title` - The title
        `in_content` - The sections
      Returns:
        A new document

    - #### documentStyle

          public static SDocumentWithSections documentStyle(SDocumentTitle in_title,
                                                            SDocumentStyle in_style,
                                                            SNonEmptyList<SSection> in_content)

      Construct a new document with the given title.
      Parameters:
        `in_title` - The title
        `in_style` - The style
        `in_content` - The sections
      Returns:
        A new document

    - #### documentStyleContents

          public static SDocumentWithSections documentStyleContents(SDocumentTitle in_title,
                                                                    SDocumentStyle in_style,
                                                                    SNonEmptyList<SSection> in_content)

      Construct a new document with the given title, style, and table of contents.
      Parameters:
        `in_title` - The title
        `in_style` - The style
        `in_content` - The sections
      Returns:
        A new document

    - #### documentAccept

          public <D> D documentAccept(SDocumentVisitor<D> v)
                               throws Exception

      Description copied from class: `SDocument`
      Accept a document visitor.
      Specified by:
        `documentAccept` in class `SDocument`
      Type Parameters:
        `D` - The type of transformed `SDocument`s
      Parameters:
        `v` - The visitor
      Returns:
        The value returned by the visitor
      Throws:
        `Exception` - If the visitor raises an `Exception`

    - #### equals

          public boolean equals(@Nullable
                                Object obj)

      Overrides:
        `equals` in class `SDocument`

    - #### getSections

          public SNonEmptyList<SSection> getSections()

      Returns:
        The document sections

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `SDocument`

Copyright © 2015 <code@io7m.com> http://io7m.com